﻿Public Class RendererConfigurationSection
    Inherits ConfigurationSection

    <ConfigurationProperty("", IsDefaultCollection:=True)> _
    Public ReadOnly Property Renderers() As RendererConfigurationCollection
        Get
            Return CType(Me(""), RendererConfigurationCollection)
        End Get
    End Property
End Class

Public Class RendererConfigurationCollection
    Inherits ConfigurationElementCollection

    Protected Overrides Function CreateNewElement() As ConfigurationElement
        Return New RendererConfigurationElement()
    End Function

    Protected Overrides Function GetElementKey(ByVal element As ConfigurationElement) As Object
        Return (CType(element, RendererConfigurationElement)).Extension
    End Function

End Class

Public Class RendererConfigurationElement
    Inherits ConfigurationElement

    <ConfigurationProperty("extension", IsRequired:=True, IsKey:=True)> _
    Public Property Extension() As String
        Get
            Return CType(Me("extension"), String)
        End Get
        Set(ByVal Value As String)
            Me("extension") = Value
        End Set
    End Property

    <ConfigurationProperty("rendererPath", IsRequired:=True)> _
    Public Property RendererPath() As String
        Get
            Return CType(Me("rendererPath"), String)
        End Get
        Set(ByVal Value As String)
            Me("rendererPath") = Value
        End Set
    End Property
End Class
