﻿Imports System.Data.Linq
Imports System.Web.Configuration
Imports System.Data.Linq.Mapping
Imports System.Web.Hosting
Imports MvcPaging

Public Class MediaRepository

    Private _dataContext As DataContext
    Private _media As Table(Of Media)

    Sub New()
        ' Get connection string from web config
        Dim conSettings As ConnectionStringSettings
        conSettings = WebConfigurationManager.ConnectionStrings("con1")
        If IsNothing(conSettings) Then
            Throw New ConfigurationErrorsException("Missing con1 database connection string.")
        End If

        ' Get XML mapping file
        Dim map = XmlMappingSource.FromUrl(HostingEnvironment.MapPath("~/Models/Media.xml"))

        ' Create DataContext
        _dataContext = New DataContext(conSettings.ConnectionString, map)

        ' Create media table
        _media = _dataContext.GetTable(Of Media)()
    End Sub

    Sub Insert(ByVal mediaToAdd As Media)
        _media.InsertOnSubmit(mediaToAdd)
        _dataContext.SubmitChanges()
    End Sub


    Sub Update(ByVal mediaToUpdate As Media)
        _dataContext.SubmitChanges()
    End Sub


    Function SelectAll() As List(Of Media)
        Return _media.ToList()
    End Function

    Function SelectRange(ByVal pageIndex As Integer, ByVal pageSize As Integer) As PageOfList(Of Media)
        Return _media.ToPageOfList(pageIndex, pageSize)
    End Function

    Function GetMedia(ByVal Id As Integer) As Media
        Return (From m In _media Where m.Id = Id).SingleOrDefault()
    End Function


End Class
