﻿Imports System.Web.Configuration
Imports System.IO

Public Class RendererMap

    Private Shared ReadOnly _map As New Dictionary(Of String, String)

    Shared Sub New()
        Dim config As RendererConfigurationSection = WebConfigurationManager.GetSection("renderers")


        For Each item As RendererConfigurationElement In config.Renderers
            Dim extension = "." & item.Extension.ToLower()
            Dim rendererPath = item.RendererPath
            _map.Add(extension, rendererPath)
        Next
    End Sub



    Public Shared Function GetRenderer(ByVal fileName As String) As String
        Dim extension = Path.GetExtension(fileName).ToLower()
        If Not _map.ContainsKey(extension) Then
            Throw New ArgumentException(extension + " is not defined in the renderers section of web.config.")
        End If
        Return _map(extension.ToLower())
    End Function


End Class
